// written 2004 Mirko Roller   mirko@mirkoroller.de
// Example shows you how to use sprites, and clear the screen...
// The sprites are generated with: bmp2bin -x name.bmp name.raw

#include <string.h>
#include <stdio.h>

#include "gp32.h"
#include "cpp_prototypes.h"
#include "cpp.h"



extern unsigned char garfield[];
extern unsigned char odie[];
extern unsigned char test[];

u16 *framebuffer[2];

char swapper=0;
void swap_screen () {
   gp_setFramebuffer((u32)framebuffer[swapper],1);
   swapper++; if (swapper == 2) swapper=0;
}

#include "..\MicroLib\uSprite.h"

int cpp_main()
{
  int spritex=50;
  int spritey=50;
  int x;
  int framerate=0;
  int refreshrate=0;
  char buffer[64]="Framerate:         ";
  framebuffer[0] = (u16*)  FRAMEBUFFER1;
  framebuffer[1] = (u16*)  FRAMEBUFFER2;

  gp_setCpuspeed(133);
  
  
  gp_initRTC();
  refreshrate=gp_initFramebuffer((u32)framebuffer[0],16,85);
  gp_clearRTC();
  
  while (1)
  {
    int spritey=50;
  //int spritex=65;
  
    ++spritex;
    ++spritey;
    // Drawing in Sprite header mode, only usefull if the sprite got a header.
    // Use it only, if your Sprite is converted with ./bmp2bin -x
    // You can use:  gp_drawSpriteT,gp_drawSprite  if your data are in raw data.
  
    swap_screen();
    gp_clearFramebuffer16(framebuffer[swapper],0xffff); // very very fast asm, faster than memset
  
/**/  
    if (gp_getButton()&BUTTON_L)
    {
      if (gp_getButton()&BUTTON_R)
      {
        gp_drawSpriteHT ((u16*)     test,102, 10, framebuffer[swapper], 0xFFFE );
        gp_drawSpriteHT ((u16*) garfield, 90, 50, framebuffer[swapper], 0xFFFE );
        gp_drawSpriteHTB((u16*)     odie,   spritex+1, spritey+1 , framebuffer[swapper], 0xFFFE,7);
        gp_drawSpriteHTB((u16*)     odie,   spritex+2, spritey+2 , framebuffer[swapper], 0xFFFE,7);
        gp_drawSpriteHTB((u16*)     odie,   spritex+3, spritey+3 , framebuffer[swapper], 0xFFFE,7);
        gp_drawSpriteHTB((u16*)     odie,   spritex+4, spritey+4 , framebuffer[swapper], 0xFFFE,7);
        gp_drawSpriteHTB((u16*)     odie,   spritex+5, spritey+5 , framebuffer[swapper], 0xFFFE,7);
        gp_drawSpriteHTB((u16*)     odie,   spritex+6, spritey+6 , framebuffer[swapper], 0xFFFE,7);
        gp_drawSpriteHTB((u16*)     odie,   spritex+7, spritey+7 , framebuffer[swapper], 0xFFFE,7);
        gp_drawSpriteHTB((u16*)     odie,   spritex+8, spritey+8 , framebuffer[swapper], 0xFFFE,7);
      }
      else
      {
        gp_drawSpriteHT((u16*)     test,100, 10, framebuffer[swapper], 0xFFFE );
        gp_drawSpriteHT((u16*) garfield, 90, 50, framebuffer[swapper], 0xFFFE );
        gp_drawSpriteHT((u16*)     odie,   spritex+1, spritey+1 , framebuffer[swapper], 0xFFFE);
        gp_drawSpriteHT((u16*)     odie,   spritex+2, spritey+2 , framebuffer[swapper], 0xFFFE);
        gp_drawSpriteHT((u16*)     odie,   spritex+3, spritey+3 , framebuffer[swapper], 0xFFFE);
        gp_drawSpriteHT((u16*)     odie,   spritex+4, spritey+4 , framebuffer[swapper], 0xFFFE);
        gp_drawSpriteHT((u16*)     odie,   spritex+5, spritey+5 , framebuffer[swapper], 0xFFFE);
        gp_drawSpriteHT((u16*)     odie,   spritex+6, spritey+6 , framebuffer[swapper], 0xFFFE);
        gp_drawSpriteHT((u16*)     odie,   spritex+7, spritey+7 , framebuffer[swapper], 0xFFFE);
        gp_drawSpriteHT((u16*)     odie,   spritex+8, spritey+8 , framebuffer[swapper], 0xFFFE);
      }
    }
    else
    {
      if (gp_getButton()&BUTTON_R)
      {
        uS_DrawSpriteHT ((u16*)     test,100, 10, framebuffer[swapper], 0xFFFE );
        uS_DrawSpriteHT ((u16*) garfield, 90, 50, framebuffer[swapper], 0xFFFE );
        uS_DrawSpriteHTB((u16*)     odie,   spritex+1, spritey+1 , framebuffer[swapper], 0xFFFE,7);
        uS_DrawSpriteHTB((u16*)     odie,   spritex+2, spritey+2 , framebuffer[swapper], 0xFFFE,7);
        uS_DrawSpriteHTB((u16*)     odie,   spritex+3, spritey+3 , framebuffer[swapper], 0xFFFE,7);
        uS_DrawSpriteHTB((u16*)     odie,   spritex+4, spritey+4 , framebuffer[swapper], 0xFFFE,7);
        uS_DrawSpriteHTB((u16*)     odie,   spritex+5, spritey+5 , framebuffer[swapper], 0xFFFE,7);
        uS_DrawSpriteHTB((u16*)     odie,   spritex+6, spritey+6 , framebuffer[swapper], 0xFFFE,7);
        uS_DrawSpriteHTB((u16*)     odie,   spritex+7, spritey+7 , framebuffer[swapper], 0xFFFE,7);
        uS_DrawSpriteHTB((u16*)     odie,   spritex+8, spritey+8 , framebuffer[swapper], 0xFFFE,7);
      }
      else
      {
        uS_DrawSpriteHT((u16*)     test,100, 10, framebuffer[swapper], 0xFFFE );
        uS_DrawSpriteHT((u16*) garfield, 90, 50, framebuffer[swapper], 0xFFFE );
        uS_DrawSpriteHT((u16*)     odie,   spritex+1, spritey+1 , framebuffer[swapper], 0xFFFE);
        uS_DrawSpriteHT((u16*)     odie,   spritex+2, spritey+2 , framebuffer[swapper], 0xFFFE);
        uS_DrawSpriteHT((u16*)     odie,   spritex+3, spritey+3 , framebuffer[swapper], 0xFFFE);
        uS_DrawSpriteHT((u16*)     odie,   spritex+4, spritey+4 , framebuffer[swapper], 0xFFFE);
        uS_DrawSpriteHT((u16*)     odie,   spritex+5, spritey+5 , framebuffer[swapper], 0xFFFE);
        uS_DrawSpriteHT((u16*)     odie,   spritex+6, spritey+6 , framebuffer[swapper], 0xFFFE);
        uS_DrawSpriteHT((u16*)     odie,   spritex+7, spritey+7 , framebuffer[swapper], 0xFFFE);
        uS_DrawSpriteHT((u16*)     odie,   spritex+8, spritey+8 , framebuffer[swapper], 0xFFFE);
      }
    }
/**/

  //uS_DrawSpriteHTB((u16*)     odie,   spritex, spritey, framebuffer[swapper], 0xFFFE, 7);
  //uS_DrawSpriteHT ((u16*)     odie,  -3      , spritey, framebuffer[swapper], 0xFFFE   );
  
    framerate++;
    if (gp_getRTC() > 63) {sprintf(buffer,"Framerate: %d,%d    ",framerate,refreshrate);framerate=0;gp_clearRTC(); }
    gp_drawString(20,220,20,buffer,0x0000,framebuffer[swapper]);
  
    if (spritex>300) spritex=-150;
    if (spritey>300) spritey=-150;
    if (gp_getButton()&BUTTON_SELECT && gp_getButton()&BUTTON_START) gp_Reset();
  }

  return 0;  
}

